﻿(function ($) {
	$.addColorPicker = function (t, p) {
		if (t.colorpicker) { return false; }
		p = $.extend({
			value: "#fff"
			, align: "left"
			, width: ""
			, onChange: null
			, isTextColor: false
		}, p);
		var g = {
			colors: p.colors || [
            '#000000', '#993300', '#333300', '#000080', '#333399', '#333333', '#800000', '#FF6600',
            '#808000', '#008000', '#008080', '#0000FF', '#666699', '#808080', '#FF0000', '#FF9900',
            '#99CC00', '#339966', '#33CCCC', '#3366FF', '#800080', '#999999', '#FF00FF', '#FFCC00',
            '#FFFF00', '#00FF00', '#00FFFF', '#00CCFF', '#993366', '#C0C0C0', '#FF99CC', '#FFCC99',
            '#FFFF99', '#CCFFFF', '#99CCFF', '#FFFFFF']
			, box: null
			, init: function () {
				g.box = $(t);
				var $a = $("<span class='current col-picker-handler'>&nbsp;</span>");
				if (p.isTextColor) {
					$a.html("<div class='text col-picker-handler'>A</div><div class='bottom col-picker-handler'>&nbsp;</div>");
				}
				g.box
				.append($a)
				.addClass("color-picker");
				var $current = $(".current", g.box);
				if (p.isTextColor) {
					$(".text", $current).css("color", p.value);
					$(".bottom", $current).css("background-color", p.value);
				} else {
					$current.css("background-color", p.value);
				}
				var $jqcol = $("<div class='color-picker-ddl'></div>");
				var $ul = $("<ul class='dropdown-menu'></ul>");
				$.each(g.colors, function (i, color) {
					var $li = $("<li><a href='javascript:void(0);' color='" + color + "'></a></li>");
					$("a", $li).css("background-color", color);
					$ul.append($li);
				});
				if (p.width != "") {
					$ul.width(p.width);
				}
				if (p.align == "left") {
					$ul.addClass("pull-left");
				}
				if (p.align == "right") {
					$ul.addClass("pull-right");
				}
				$("a", $ul).click(function () {
					var color = $(this).attr("color");
					var $cur = $(".current", t);
					if (p.isTextColor) {
						$(".text", $cur).css("color", color);
						$(".bottom", $cur).css("background-color", color);
					} else {
						$cur.css("background-color", color);
					}
					if (p.onChange) {
						p.onChange(color);
					}
					$jqcol.hide().removeClass("open");
				});
				$jqcol.append($ul);
				$("body").append($jqcol);
				$current
				.click(function () {
					$(".color-picker-ddl").hide();
					var $this = $(this);
					var pos = $this.offset();
					$ul
					.removeClass("pull-bottom")
					.removeClass("pull-top")
					;

					$jqcol
					.show()
					.addClass("open");
					var browserWidth = document.documentElement.clientWidth;
					var browserHeight = document.documentElement.clientHeight;
					var scrollX = document.documentElement.scrollLeft || document.body.scrollLeft;
					var scrollY = document.documentElement.scrollTop || document.body.scrollTop;

					var jqcolHeight = $ul.height();
					var jqcolwidth = $ul.width();
					var calctop = pos.top + jqcolHeight + $this.height();
					var calcleft = pos.left + jqcolwidth + $this.width();
					var $bdy = $("body");
					//document.title = (browserHeight + scrollY) + " : " + calctop;
					var top = pos.top + $this.height();
					var left = pos.left + $this.width();
					if (calctop > (browserHeight + scrollY)) {
						top = ((pos.top - jqcolHeight) - $this.height()) + 10;
						$ul.addClass("pull-bottom");
					} else {
						$ul.addClass("pull-top");
					}
					//document.title = (browserWidth + scrollX) + " : " + calcleft;
					if (calcleft < (browserWidth + scrollX)) {
						left = pos.left;
						$ul.removeClass("pull-right").addClass("pull-left");
					} else {
						left = pos.left + $this.width();
						$ul.removeClass("pull-left").addClass("pull-right");
					}
					$jqcol.css({
						"top": top, "left": left
					});
				});

			}
		};
		g.init();
		t.colorpicker = g;
		if (colbodyclick == false) {
			colbodyclick = true;
			$("body")
			.click(function (e) {
				if (!$(e.target).hasClass("col-picker-handler")) {
					$(".color-picker-ddl").hide();
				}
			});
		}
		return t;
	};
	var coldocloaded = false;
	var colbodyclick = false;
	$(document).ready(function () { coldocloaded = true });
	$.fn.colorpicker = function (p) {
		return this.each(function () {
			if (!coldocloaded) {
				$(this).hide();
				var t = this;
				$(document).ready
					(
						function () {
							$.addColorPicker(t, p);
						}
					);
			} else {
				$.addColorPicker(this, p);
			}
		});
	};
})(jQuery);
