﻿/*
ko.bindingHandlers.textI	= {
	update: function(element, params){
		params	= ko.utils.unwrapObservable(params)();

		var ret	= null;
		if (typeof params === "object")
		{
			var val	= ko.utils.unwrapObservable(params.val);
			if (val && ko.utils.unwrapObservable(params.isPassword))
			{
				ret	= "*********";
//				ret	= new Array(val.length+1).join("*");//repeat("*").repeat();
			}

			if (!val)
			{
				ret	= "--";
			}
		}
		else if (!ko.utils.unwrapObservable(params))
		{
			ret	= "--";
		}

		return ko.bindingHandlers.text.update(element, function(){
			return ret ? ret : params;
		});
	}
};
*/
window.OTSetup	= new function OTSetup(){
	var _this	= this;

	_this.isDependent	= false;

	_this.siteUrl	= "";

	_this.Steps	= {
		REQUIREMENTS: 0,
		DB_CONFIG: 1,
		OTHER_DETAILS: 2,
		SMTP_CONFIG: 3,
		FINISH: 4,
		INSTALLED: 5
	};

	_this.showMsg	= function(msg){
		var message	=  '<div class="alert alert-danger">';
			//message	+= '	<button type="button" class="close" data-dismiss="alert">&times;</button>';
			message	+= msg;
			message	+= '</div>';

		var elem	= $("#alert_message");
		elem.html(message);
		setTimeout(function(){
			elem.html("");
		}, 3000);
	};

	_this.SetupModel	= function(data){
		var self	= this;

		data	= data || {};

		// 0 - Pre Requirements
		// 1 - Database Config
		// 2 - Other Details
		// 3 - SMTP Config
		// 4 - Finish
		self.step	= ko.observable(0);

		self.title	= ko.observable("Outputtime Installation (PreRequirements)");

		self.show_loading	= ko.observable(false);

		self.preRequirement	= ko.observableArray([]);

//		var testRecords	= [{
//			database: "output"
//		},{
//			smtp_host:"ssl://smtpout.secureserver.net",
//			smtp_port:"465",
//			smtp_user:"noreply@outputtime.com",
//			smtp_pass:"noreplyotime"
//		},{
//			email: "sdssdasd@gmail.com",
//			password: "admin123",
//			first_name: "sdssdasd",
//			last_name: "sdssdasd",
//			license_key: "VFQA0YzjqPgct8mPaY++09Kktq7PabKxoMXf0tax2dd5eoZ4U4uqm6V9l5mDd4pkccnq1tZwr8i3uMVhWMmjir3Eyw=="
//		}];

		self.dbConfig	= ko.observable(new _this.DBConfig());
		self.smtpConfig	= ko.observable(new _this.SmtpConfig());
		self.otherDetails	= ko.observable(new _this.OtherDetails());
		self.licenseDetails	= ko.observable();

		var setTitle	= function(isFromNext){
			switch(self.step())
			{
				case _this.Steps.REQUIREMENTS:
					self.title("Outputtime Installation (PreRequirements)");
					break;
				case _this.Steps.DB_CONFIG:
					self.title("Outputtime Installation (Database Configuration)");
					break;
				case _this.Steps.SMTP_CONFIG:
					self.title("Outputtime Installation (SMTP Configuration)");
					break;
				case _this.Steps.OTHER_DETAILS:
					self.title("Outputtime Installation (Other Details)");
					break;
				case _this.Steps.FINISH:
					self.title("Outputtime Installation (Verification)");
					break;
				default:
					self.step(isFromNext ? _this.Steps.FINISH : 0);
					setTitle();
					break;
			}
		};

		setTitle();

		var saveConfig	= function(postData){
			self.show_loading(true);
			$.post(_this.siteUrl + "/setup/install", postData, function(response){
				self.show_loading(false);
				if (response[0])
				{
					self.step(self.step()+1);
//					setTitle(true);
//					_this.Steps.INSTALLED;
//					window.location.reload();
				}
				else
				{
					_this.showMsg(response[1]);
				}
			}, "JSON").fail(function(){
				self.show_loading(false);
				_this.showMsg("Unknown Error in Ajax Call.");
			});
		};

		var nxt	= function(){
			self.step(self.step()+1);
//			if (self.step() == _this.Steps.SMTP_CONFIG)
//			{
//				self.next();
//				return;
//			}

			setTitle(true);
		};

		var checkDbExist	= function(){
			var dbConf	= self.dbConfig();
			if (dbConf.dbdriver() && dbConf.hostname() && dbConf.database() && dbConf.username())
			{
				var postData	= {
					dbconfig: JSON.parse(ko.toJSON(self.dbConfig))
				};
				self.show_loading(true);
				$.post(_this.siteUrl + "/setup/db_exist", postData, function(response){
					self.show_loading(false);
					if (response[0])
					{
						nxt();
					}
					else
					{
						_this.showMsg(response[1]);
					}
				}, "JSON").fail(function(){
					self.show_loading(false);
					_this.showMsg("Unknown Error in Ajax Call.");
				});
			}
			else
			{
				_this.showMsg("Missing required fields values.");
			}
		};

		var checkLicense	= function(){
			var other_details	= self.otherDetails();
			if (other_details.license_key())
			{
				var postData	= {
					license_key: other_details.license_key()
				};
				self.show_loading(true);
				$.post(_this.siteUrl + "/setup/check_license", postData, function(response){
					self.show_loading(false);
					if (response[0])
					{
						var ld	= response[2].license_detail;
						ld.license_key	= other_details.license_key();
						ld.max_users	= (ld.max_users-0) || 'Unlimited';
						self.licenseDetails(ld);
						nxt();
					}
					else
					{
						_this.showMsg(response[1]);
					}
				}, "JSON").fail(function(){
					self.show_loading(false);
					_this.showMsg("Unknown Error in Ajax Call.");
				});
			}
			else
			{
				_this.showMsg("License key missing.");
			}
		};

		var testEmail	= function(){
			var smtpConfig	= self.smtpConfig();

			if (smtpConfig.smtp_host() && smtpConfig.smtp_port() && smtpConfig.smtp_user() && smtpConfig.smtp_pass())
			{
				var postData	= {
					smtp_config: JSON.parse(ko.toJSON(self.smtpConfig)),
					to_email: self.otherDetails().email(),
					license_key: self.otherDetails().license_key()
				};
				$.post(_this.siteUrl + "/setup/test_email", postData, function(response){
					self.show_loading(false);
					if (response[0])
					{
						nxt();
					}
					else
					{
						_this.showMsg(response[1]);
					}
				}, "JSON").fail(function(){
					self.show_loading(false);
					_this.showMsg("Unknown Error in Ajax Call.");
				});
			}
			else
			{
				_this.showMsg("Invalid field values.");
			}

			return true;
		};

		self.skip	= function(item, elem){
			if (self.step() == _this.Steps.SMTP_CONFIG)
			{
				nxt();
				return true;
			}
		};

		self.next	= function(item, elem){
			// if any minimum requirement not meat not allow to go next.
			if (_this.isDependent)
			{
				return;
			}

			if (self.step() == _this.Steps.DB_CONFIG)
			{
				checkDbExist();
				return true;
			}

			if (self.step() == _this.Steps.OTHER_DETAILS)
			{
				checkLicense();
				return true;
			}

			if (self.step() == _this.Steps.SMTP_CONFIG)
			{
				testEmail();
				return true;
			}

			if (self.step() == _this.Steps.FINISH)
			{
				if (!self.dbConfig().isValid() || !self.otherDetails().isValid())
				{
					return false;
				}

				var postData	= {
					dbconfig: JSON.parse(ko.toJSON(self.dbConfig)),
					smtpConfig: JSON.parse(ko.toJSON(self.smtpConfig)),
					otherDetails: JSON.parse(ko.toJSON(self.otherDetails))
				};
				saveConfig(postData);
				return;
			}
			nxt();
		};

		self.prev	= function(){
			self.step(self.step()-1);
//			if (self.step() == _this.Steps.SMTP_CONFIG)
//			{
//				self.prev();
//				return;
//			}
			setTitle();
		};

		

		self.stepText	= ko.computed(function(){
			return "&nbsp;Step " + (self.step()+1) + " / " + Object.keys(_this.Steps).length + "&nbsp;";
		});
	};

	_this.DBConfig	= function(data){
		var self	= this;

		data	= data || {};

		self.dbdriver	= ko.observable(data.dbdriver || "mysql");
		self.hostname	= ko.observable(data.hostname || "localhost").extend({ required:true });
		self.database	= ko.observable(data.database || "").extend({ required:true });
//		self.dbprefix	= ko.observable("").extend({ maxLength:20 });
		self.username	= ko.observable(data.username || "root").extend({ required:true });
		self.password	= ko.observable(data.password || "");

//		self.dbprefix.subscribe(function(newVal){
//			if(!newVal)
//			{
//				self.dbprefix("ot_");
//				return;
//			}
//
//			if (newVal && newVal.substr(-1) != "_")
//			{
//				self.dbprefix(newVal + "_");
//			}
//		});

		self.isValid	= function(){
			var msgs	= "";
			if (!self.hostname.isValid())
			{
				msgs	+= "Host name required" + '<br>';
			}

			if (!self.database.isValid())
			{
				msgs	+= "Database name required" + '<br>';
			}

			if (!self.username.isValid())
			{
				msgs	+= "User name required" + '<br>';
			}

			if(msgs != '')
			{
				_this.showMsg(msgs, 'danger', $("#alert_message"));
				return false;
			}

			return true;
		};

		self.onSubmit	= function(item, elem){
			if (!self.isValid())
			{
				return false;
			}
		};

		return self;
	};

	_this.SmtpConfig	= function(data){
		var self	= this;

		data	= data || {};

		self.smtp_host	= ko.observable(data.smtp_host || "");
		self.smtp_port	= ko.observable(data.smtp_port || "");
		self.smtp_user	= ko.observable(data.smtp_user || "");
		self.smtp_pass	= ko.observable(data.smtp_pass || "");
	};

	_this.OtherDetails	= function(data){
		var self	= this;

		data	= data || {};

		self.email				= ko.observable("").extend({ required:true, email:true, maxLength:80 });
		self.password			= ko.observable("").extend({ required:true, minLength:6, maxLength:12 });
		self.confirm_password	= ko.observable("").extend({ required:true, minLength:6, maxLength:12 });
		self.first_name			= ko.observable("").extend({required:true, minLength:4, maxLength:60});
		self.last_name			= ko.observable("");
		self.license_key		= ko.observable(data.license_key || "").extend({required:true});
		var tz	= ((-new Date().getTimezoneOffset())/60);
		var tz_prefix	= tz < 0 ? "UM" : (tz > 0 ? "UP" : "UTC");
		self.time_zone	= (tz_prefix == "UTC" ? "UTC" : (tz_prefix + tz).replace(".",""));

		self.confirm_password.subscribe(function(newVal){
			if (newVal && self.password() != newVal)
			{
				alert("Confirm password not match with password.");
				self.confirm_password("");
				return false;
			}
			else if(!newVal)
			{
				return false;
			}
		});

		self.isValid	= function(){
			var msgs	= "";
			if (self.first_name().length > 0 && self.first_name().length < 4  )
			{
				msgs	+= 'First name field should be minimum 4 characters.'+'<br>';
			}
			else if (!self.first_name.isValid())
			{
				msgs	+= 'First name required.'+'<br>';
			}

			if (!self.email.isValid())
			{
				msgs	+= 'Invalid email address.'+'<br>';
			}

			if (self.password().length > 0 && self.password().length < 6  )
			{
				msgs	+= 'Password field should be minimum 6 characters.'+'<br>';
			}
			else if (!self.password.isValid())
			{
				msgs	+= 'Password field required.'+'<br>';
			}

			if (self.password() && !self.confirm_password())
			{
				msgs	+= 'Confirm password required'+'<br>';
			}
			if (self.confirm_password() && self.confirm_password() != self.password())
			{
				msgs	+= 'Confirm password not match with password'+'<br>';
			}

			if (self.license_key().length > 0 && self.license_key().length < 4  )
			{
				msgs	+= 'License key field should be minimum 4 characters.'+'<br>';
			}
			else if (!self.license_key.isValid())
			{
				msgs	+= 'License key required.'+'<br>';
			}

			if(msgs != '')
			{
				_this.showMsg(msgs, 'danger', $("#alert_message"));
				return false;
			}

			return true;
		};
	};

	_this.init	= function(){
		var setup_container	= $("#setup-container");
		_this.appModel	= new _this.SetupModel();
		ko.applyBindings(_this.appModel, setup_container.get(0));
	};
};
